package com.qmth.themis.backend.elasticsearch.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import org.springframework.data.annotation.Id;
import org.springframework.data.elasticsearch.annotations.Document;
import org.springframework.data.elasticsearch.annotations.Field;
import org.springframework.data.elasticsearch.annotations.FieldType;

import java.io.Serializable;
import java.util.Date;

/**
 * @Description: elasticsearch 学生档案 entity
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2020/7/6
 */
@ApiModel(value = "TEStudent", description = "学生档案")
@Document(indexName = "student_index", shards = 1, replicas = 0)
public class ETEStudentEntity implements Serializable {
    private static final long serialVersionUID = 1L;

    @Id
    @ApiModelProperty(value = "主键")
    @TableId(value = "id")
    private Long id;

    @ApiModelProperty(value = "机构ID")
    @TableId(value = "org_id")
    private Long orgId;

    @ApiModelProperty(value = "证件号")
    @TableId(value = "identity")
//    @Field(type = FieldType.Keyword)
//    @Field(type = FieldType.Auto)
    private String identity;

    @ApiModelProperty(value = "登陆密码，密文保存")
    @TableId(value = "password")
    private String password;

    @ApiModelProperty(value = "身份证号")
    @TableId(value = "idcard_number")
    private String idcardNumber;

    @ApiModelProperty(value = "手机号")
    @TableId(value = "mobile_number")
    @Field(type = FieldType.Text, analyzer = "ik_max_word")
    private String mobileNumber;

    @ApiModelProperty(value = "姓名")
    @TableId(value = "name")
    @Field(type = FieldType.Text, analyzer = "ik_max_word")
    //keyword：存储数据时候，不会分词建立索引
    //text：存储数据时候，会自动分词，并生成索引（这是很智能的，但在有些字段里面是没用的，所以对于有些字段使用text则浪费了空间）。
    private String name;

    @ApiModelProperty(value = "性别")
    @TableId(value = "gender")
//    @Field(type = FieldType.Integer)
    private Integer gender;

    @ApiModelProperty(value = "底照保存地址")
    @TableId(value = "base_photo_path")
    private String basePhotoPath;

    @ApiModelProperty(value = "创建时间")
    @TableId(value = "create_time")
    private Date createTime;

    @ApiModelProperty(value = "更新时间")
    @TableId(value = "update_time")
    private Date updateTime;

    public static long getSerialVersionUID() {
        return serialVersionUID;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getOrgId() {
        return orgId;
    }

    public void setOrgId(Long orgId) {
        this.orgId = orgId;
    }

    public String getIdentity() {
        return identity;
    }

    public void setIdentity(String identity) {
        this.identity = identity;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public String getIdcardNumber() {
        return idcardNumber;
    }

    public void setIdcardNumber(String idcardNumber) {
        this.idcardNumber = idcardNumber;
    }

    public String getMobileNumber() {
        return mobileNumber;
    }

    public void setMobileNumber(String mobileNumber) {
        this.mobileNumber = mobileNumber;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Integer getGender() {
        return gender;
    }

    public void setGender(Integer gender) {
        this.gender = gender;
    }

    public String getBasePhotoPath() {
        return basePhotoPath;
    }

    public void setBasePhotoPath(String basePhotoPath) {
        this.basePhotoPath = basePhotoPath;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }
}
